import React, {PureComponent} from 'react';
import {modelActionsForToggleButton} from '../button-initial-state';
import {ButtonsTestComponent} from '../../playground/buttons-test-component';
import {XlReactToggleButton} from '../../../xl-react-buttons/xl-react-toggle-button/xl-react-toggle-button';
import {itemType} from './item-type';

export class ToggleButton extends PureComponent {
    static propTypes = itemType;

    handleToggle = (value) => {
        const {updateModel, modelName} = this.props;
        updateModel(modelName, value)();
    };

    render() {
        const {modelName, state} = this.props;
        return <ButtonsTestComponent {...state[modelName]}>
            <XlReactToggleButton
                metadata={modelActionsForToggleButton}
                model={state[modelName].model}
                objLabel="label"
                onToggle={this.handleToggle}
                type="secondary"
            />
        </ButtonsTestComponent>;
    }
}
