import R from 'ramda';
import {getHandlers} from '../handlers/predefined-handlers';

const invalidItems = ['Applications/ZooApp/2.0', 'Application1'];

const validateItems = async (items) =>
    await R.map((model) => ({
        model,
        valid: !R.pipe(
            R.head,
            R.contains(R.__, invalidItems)
        )(model)
    }), items);

export const getCollectionOfCiHandlers = {
    ...getHandlers(),
    validateItems
};
