import R from 'ramda';
import {Promise} from 'es6-promise';

const defaultSuggestedElements = [
    {id: 'Application1', type: '1'},
    {id: 'Application2', type: '2'},
    {id: 'Application3', type: '3'},
    {id: 'Application4', type: '4'},
    {id: 'Application5', type: '5'},
    {id: 'Application6', type: '6'}];

export const lookupSuggestedElements = [
    {id: 'Configuration/Vault/LookupValueProvider', type: '1'},
    {id: 'Configuration/VaultProvider1', type: '1'},
    {id: 'Configuration/VaultProvider2', type: '1'},
    {id: 'Configuration/VaultProvider3', type: '1'},
    {id: 'Configuration/VaultProvider4', type: '1'},
    {id: 'Configuration/VaultProvider5', type: '1'}
];

const addCandidates = ({value, objLabel, suggestedElements = defaultSuggestedElements}) => {
    const filterCond = (item) => R.toLower(item[objLabel]).indexOf(R.toLower(value)) !== -1;
    const res = R.filter(filterCond, suggestedElements);
    return Promise.resolve(res);
};

export const autocompleteHandlers = {addCandidates};

export const getHandlers = (suggestedElements) => ({
    addCandidates: ({metadata, value, objLabel}) => addCandidates({
        metadata,
        objLabel,
        suggestedElements,
        value
    })
});
