import R from 'ramda';
import {Promise} from 'es6-promise';
import colors from '../../styles/variables';

const longValue = 'ZApp very very very very very very very very very very very very very very very very very' +
    ' very very very very very very very very very very very very long name';

const suggestedElements = [
    ...R.map((ind) => ({
        color: colors['xl-green'],
        label: `Application ${ind}`,
        value: `Applications/TestApp/Application ${ind}`
    }), R.range(0, 40)),
    {
        color: colors['xl-red'],
        label: longValue,
        value: longValue
    }
];

const addCandidates = ({model, objLabel, value}) => {
    const filterCond = (item) => R.toLower(item[objLabel]).indexOf(R.toLower(value)) !== -1;

    const res = R.pipe(
        R.concat(suggestedElements),
        R.uniq,
        R.filter(filterCond),
        R.sortBy(R.compose(R.toLower, R.prop(objLabel)))
    )(model);

    return Promise.resolve(res);
};

export const getHandlers = (model) => ({
    addCandidates: ({metadata, value, objLabel}) => addCandidates({metadata, model, objLabel, value}),
    onClick: R.F,
    onNewItem: R.F
});
