import R from 'ramda';
import {Promise} from 'es6-promise';
import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';
import {XlReactWidgetAutocomplete} from
    '../../../xl-react-widget/xl-react-widget-autocomplete/xl-react-widget-autocomplete';

export default class DisplaySelectComponent extends PureComponent {
    static propTypes = {
        clazzName: PropTypes.string,
        currentValue: PropTypes.string,
        label: PropTypes.string.isRequired,
        listOfValues: PropTypes.array.isRequired,
        name: PropTypes.string.isRequired,
        onSelectChange: PropTypes.func.isRequired
    };

    autocompleteHandlers = {addCandidates: () => Promise.resolve(R.map((id) => ({id}), this.props.listOfValues))};

    render() {
        const {clazzName, currentValue, label, name, onSelectChange} = this.props;

        return <div className={clazzName}>
            <span className="label">{label}</span>
            <XlReactWidgetAutocomplete
                handlers={this.autocompleteHandlers}
                metadata={{name}}
                model={currentValue}
                onModelChange={onSelectChange}
            />
        </div>;
    }
}
