import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';
import DisplayComponent from '../sink/display-component';
import ElementNavTitle from './element-nav-title';

export class ButtonsTestComponent extends PureComponent {
    static propTypes = {
        children: PropTypes.element.isRequired,
        className: PropTypes.string.isRequired,
        model: PropTypes.any.isRequired,
        modelName: PropTypes.any.isRequired,
        navigationDescription: PropTypes.string.isRequired,
        navigationTitle: PropTypes.string.isRequired
    };

    render() {
        const {
            children, className, model, modelName, navigationDescription, navigationTitle
        } = this.props;

        return <div>
            <ElementNavTitle
                description={navigationDescription}
                modelName={modelName}
                title={navigationTitle}
                type={'button'}
            />

            <div className={className}>
                <div className="testComponent">
                    {children}
                </div>
                <div className="testBindings">
                    <DisplayComponent className="model" label={'Model'} value={model}/>
                </div>
            </div>
        </div>;
    }
}
