import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';
import RU from '../../utils/ramda-utils';
import './alert-switcher.less';

export default class AlertSwitcher extends PureComponent {
    static propTypes = {
        alertTypes: PropTypes.string.isRequired,
        changeType: PropTypes.func.isRequired,
        chosenType: PropTypes.string.isRequired,
        groupName: PropTypes.string.isRequired
    };

    render() {
        const {alertTypes, changeType, chosenType, groupName} = this.props;

        const radioOption = (type, ind) => {
            const inputType = type.trim();

            const handleChange = () => {
                changeType(inputType);
            };

            return <span key={ind}>
                <input
                    checked={chosenType === inputType}
                    name={groupName}
                    onChange={handleChange}
                    type="radio"
                    value={inputType}
                />{inputType}
            </span>;
        };

        return <div className="alert-switcher">
            {RU.mapIndexed(radioOption, alertTypes.split(','))}
        </div>;
    }
}
