import moment from 'moment';

export const genericDateFormat = 'MMM D, YYYY';
export const validDateExample = 'Dec 1, 2018';
export const genericTimeFormatWithSeconds = 'h:mm:ss A';
export const genericTimestampFormatWithSeconds = `${genericDateFormat} - ${genericTimeFormatWithSeconds}`;

export const isDateInRange = ({checkedDate, maxDate, minDate}) => {
    const getDate = (value) => moment.isMoment(value) ? value.toDate()
        .getTime() : value.getTime();

    const isNotLaterThan = () => !(maxDate && getDate(checkedDate) > getDate(maxDate));
    const isNotEarlierThan = () => !(minDate && getDate(checkedDate) < getDate(minDate));

    return checkedDate && isNotLaterThan() && isNotEarlierThan();
};

export const toMoment = (value, dateFormat = genericDateFormat) => moment(value, dateFormat, true);
