import {useState, useEffect} from 'react';

export const useBeforeFirstRender = (func) => {
    const [hasRendered, setHasRendered] = useState(false);
    useEffect(() => setHasRendered(true), [hasRendered]);
    if (!hasRendered) {
        func();
    }
};
