import R from 'ramda';
import RU from '../utils/ramda-utils';

export const delayedHandler = (component, handler, event) => {
    if (component.state.clickable) {
        RU.invoke(handler, [event], component.props);
        component.setState({clickable: false}, () => {
            component.timeouts.push(
                setTimeout(() => component.setState({clickable: true}), component.props.inactiveTime)
            );
        });
    }
};

export const labelToClassName = (label) => {
    const labelText = R.is(String, label) ? R.toLower(label) : '';
    return R.replace(/ /g, '-', labelText);
};

export const clearTimeouts = R.forEach(clearTimeout);
