import React, {Component} from 'react';
import PropTypes from 'prop-types';
import {isComponentDisabled} from '../../utils/components-utils';

import {XlReactDipContainerProps} from '../xl-react-dip-props';
import RU from '../../utils/ramda-utils';
import {XlReactDipEnumComponent} from './xl-react-dip-enum-component';

export class XlReactDipEnum extends Component {
    static propTypes = {
        model: PropTypes.string,
        ...XlReactDipContainerProps
    };
    static defaultProps = {validators: []};

    constructor(props) {
        super(props);
        RU.invoke('register', [this.api], props);
    }

    handleModelChange = (model) => {
        this.props.onModelChange(model);
    };

    api = {focus: () => this.childApi.focus()};

    registerChildApi = (childApi) => {
        this.childApi = childApi;
    };

    render() {
        const {
            model,
            message,
            metadata,
            valid
        } = this.props;
        const disabled = isComponentDisabled(this.props);

        return <XlReactDipEnumComponent {...({
            disabled,
            message,
            metadata,
            model,
            onModelChange: this.handleModelChange,
            registerChildApi: this.registerChildApi,
            valid,
            view: metadata.view
        })}
        />;
    }
}
