import R from 'ramda';
import RU from '../../utils/ramda-utils';

export const apiFocus = (context) => {
    const allFieldsAreValid = R.anyPass([
        R.isNil,
        R.isEmpty,
        R.compose(R.all(R.equals(true)), R.values)
    ])(context.valid);
    if (allFieldsAreValid) {
        R.pipe(
            R.values,
            R.head,
            RU.invoke('focus', [])
        )(context.componentApis);
    } else {
        R.pipe(
            R.pickBy(R.equals(false)),
            R.keys,
            R.head,
            R.prop(R.__, context.componentApis),
            RU.invoke('focus', [])
        )(context.valid);
    }
};
