import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';
import R from 'ramda';

import {localeMessages} from '../../services/locale-service';
import './search-panel.less';

export class SearchPanelComponent extends PureComponent {
    static propTypes = {
        handleCleaningSearchWord: PropTypes.func.isRequired,
        handleSearchChanged: PropTypes.func.isRequired,
        searchWord: PropTypes.string.isRequired
    };

    render() {
        const {handleCleaningSearchWord, handleSearchChanged, searchWord} = this.props;

        return <div className="search-panel">
            <input
                onChange={handleSearchChanged}
                placeholder={localeMessages.searchLabel}
                type="text"
                value={searchWord}
            />
            {!R.isEmpty(searchWord) ?
                <i className="xl-icon close-icon" onClick={handleCleaningSearchWord}/> : null}
        </div>;
    }
}
