import R from 'ramda';
import RS from 'ramdasauce';

export const getNewInputValue = (model, objLabel) => objLabel ? R.path([objLabel], model) : model;

export const testModel = (model, nextModel) => R.allPass([
    R.is(Object),
    R.complement(RS.isNilOrEmpty),
    R.complement(R.equals(model))
])(nextModel);

export const computeNewState = (props, nextProps, component) => {
    const {model} = props;
    const {model: nextModel, objLabel} = nextProps;
    if (testModel(model, nextModel)) {
        component.setState({inputValue: getNewInputValue(nextModel, objLabel)});
    } else if (!R.is(Object, nextModel)) {
        component.setState({inputValue: nextModel});
    }
};
