import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';
import {XlReactFormItemControl} from '../../xl-react-form/xl-react-form-item-control';
import './xl-react-widget-filter.less';

export class XlReactWidgetFilterComponent extends PureComponent {
    static propTypes = {
        handleChange: PropTypes.func,
        handleClear: PropTypes.func,
        label: PropTypes.string,
        model: PropTypes.string,
        placeholder: PropTypes.string
    };

    render() {
        const {handleClear, handleChange, model, placeholder} = this.props;

        return <XlReactFormItemControl {...({...this.props, controlClass: 'xl-react-widget-filter'})}>
            <span className="with-search">
                <i className="xl-icon search-icon"/>
                {model ? <i className="xl-icon close-icon" onClick={handleClear}/> : null}
                <input onChange={handleChange} placeholder={placeholder} type="text" value={model}/>
            </span>
        </XlReactFormItemControl>;
    }
}
