import React, {PureComponent} from 'react';
import PropTypes from 'prop-types';

import './xl-react-widget-label.less';

export class XlReactWidgetLabel extends PureComponent {
    static propTypes = {
        metadata: PropTypes.shape({
            label: PropTypes.string,
            required: PropTypes.bool,
            requiredDirection: PropTypes.oneOf(['left', 'right'])
        }).isRequired
    };

    static defaultProps = {metadata: {}};

    createRequired() {
        return this.props.metadata.required ? <span className="required">*</span> : null;
    }

    render() {
        const {label, requiredDirection = 'right'} = this.props.metadata;

        return (
            <div className="xl-react-components-label">
                <label>
                    {requiredDirection === 'left' && this.createRequired()}
                    {label}
                    {requiredDirection === 'right' && this.createRequired()}
                </label>
            </div>
        );
    }
}
