import R from 'ramda';
import React from 'react';

export const positionColumns = (config) => {
    const leftPad = (val) => String(val).padStart(2, '0');
    const toNumber = ({position: {row, column}}) => Number(`${leftPad(row)}${leftPad(column)}`);
    const comp = R.comparator((f1, f2) => toNumber(f1) < toNumber(f2));
    return R.sort(comp, config);
};

export const buildColumns = (filters, config) => {
    const positionedColumns = positionColumns(config);

    return R.reduce((acc, item) => {
        const columnRow =
            <div
                className={`filters-panel-row ${item.position.row}`}
                key={`${item.position.row}-${item.position.column}`}>
                {filters[item.type](item)}
            </div>;

        if (acc[item.position.column]) {
            acc[item.position.column].push(columnRow);
            return acc;
        }

        return [...acc, [columnRow]];
    }, [], positionedColumns);
};
