import {call, put, select} from 'redux-saga/effects';
import tableActions from '../xl-react-widget-redux-table-actions';
import {buildMetadata} from '../query-builder-utils';
import {getTableById} from '../xl-react-widget-table-selectors';
import {fetchData, withSpinner} from './xl-react-widget-redux-table-common-saga';

export function* paginate({api, page, resultsPerPage, tableId}) {
    const {paging} = yield select(getTableById, tableId);
    yield put(tableActions.setPaging(tableId, page, resultsPerPage));
    yield call(fetchData, tableId, api, buildMetadata('paging', paging));
}

export function* paginateSaga({api, page, resultsPerPage, tableId}) {
    yield call(withSpinner, tableId, call(paginate, {api, page, resultsPerPage, tableId}));
}
