import {INPUT_DEBOUNCE_TIME} from './xl-react-widget-redux-table-constants';

const CHANGE_LOADING_STATE = '@xl-react-widget-redux-table/CHANGE_LOADING_STATE';
const FILTER = '@xl-react-widget-redux-table/FILTER';
const INITIALIZE = '@xl-react-widget-redux-table/INITIALIZE';
const MERGE_CONTEXT = '@xl-react-widget-redux-table/MERGE_CONTEXT';
const PAGINATE = '@xl-react-widget-redux-table/PAGINATE';
const REFRESH = '@xl-react-widget-redux-table/REFRESH';
const SET_FILTERS = '@xl-react-widget-redux-table/SET_FILTERS';
const SET_PAGING = '@xl-react-widget-redux-table/SET_PAGING';
const SET_SORTING = '@xl-react-widget-redux-table/SET_SORTING';
const SET_STAGED_FILTERS = '@xl-react-widget-redux-table/SET_STAGED_FILTERS';
const SHOW = '@xl-react-widget-redux-table/SHOW';
const SORT = '@xl-react-widget-redux-table/SORT';
const UNMOUNT = '@xl-react-widget-redux-table/UNMOUNT';

export default {
    CHANGE_LOADING_STATE,
    changeLoadingState: (tableId, loading) => ({loading, tableId, type: CHANGE_LOADING_STATE}),
    FILTER,
    filter: (tableId, api, filter) => ({api, filter, tableId, type: FILTER}),
    INITIALIZE,
    initialize:
        (
            {
                api,
                tableId,
                filters,
                filtersDebounceTime = INPUT_DEBOUNCE_TIME,
                layout,
                loading,
                paging,
                sorting,
                ...rest
            }
        ) => ({
            api,
            filters,
            filtersDebounceTime,
            layout,
            loading,
            paging,
            rest,
            sorting,
            tableId,
            type: INITIALIZE
        }),
    MERGE_CONTEXT,
    mergeContext: (tableId, context) => ({context, tableId, type: MERGE_CONTEXT}),
    PAGINATE,
    paginate: (tableId, api, page, resultsPerPage) => ({
        api,
        page,
        resultsPerPage,
        tableId,
        type: PAGINATE
    }),
    REFRESH,
    refresh: ({api, tableId}) => ({api, tableId, type: REFRESH}),
    SET_FILTERS,
    SET_PAGING,
    SET_SORTING,
    SET_STAGED_FILTERS,
    setFilters: (tableId, filter) => ({filter, tableId, type: SET_FILTERS}),
    setPaging: (tableId, page, resultsPerPage) => ({page, resultsPerPage, tableId, type: SET_PAGING}),
    setSorting: (tableId, name, order) => ({name, order, tableId, type: SET_SORTING}),
    SHOW,
    show: ({data = [], error, tableId, total}) => ({data, error, tableId, total, type: SHOW}),
    SORT,
    sort: (tableId, api, name, order) => ({api, name, order, tableId, type: SORT}),
    UNMOUNT,
    unmount: (tableId) => ({tableId, type: UNMOUNT})
};
