import R from 'ramda';

export const getTableById = (state, tableId) => R.path(['tables', tableId], state);

export const getTables = (state) => state.tables;

export const getLayout = (state, tableId) => R.path(['tables', tableId, 'layout'], state);

export const getSorting = (state, tableId) => R.path(['tables', tableId, 'sorting'], state);

export const getSortingWithSortKey = (state, tableId) => {
    const sorting = getSorting(state, tableId);
    const layout = getLayout(state, tableId);
    return R.evolve({name: (name) => R.find(R.propEq('dataKey', name), layout).sortKey}, sorting);
};
