import R from 'ramda';
import RU from '../../utils/ramda-utils';

export const extractFilters = R.pipe(
    R.toPairs,
    R.reduce((acc, [key, filterObject]) => ({...acc, [key]: R.propOr('', 'filterVal', filterObject)}), {})
);

export const shouldShowFilters = R.allPass([
    R.compose(RU.isDefined, R.prop('filter')),
    R.compose(RU.isDefined, R.prop('onFilterChange'))
]);

export const mergeFilters = (extractedFilters, filters) => R.pipe(
    R.toPairs,
    R.reduce((acc, [col]) => ({...acc, [col]: R.propOr('', col, extractedFilters)}), {})
)(filters);
