import R from 'ramda';
import padStart from 'string.prototype.padstart';

export const AM_DIFF = 12;

export const changeAmPm = R.cond([
    [R.gte(R.__, AM_DIFF), R.subtract(R.__, AM_DIFF)],
    [R.lt(R.__, AM_DIFF), R.add(AM_DIFF)]
]);

export const addMinute = (currentMinutes) => {
    const minutes = currentMinutes + 1;
    return minutes > 59 ? 0 : minutes;
};

export const deductMinute = (currentMinutes) => {
    const minutes = currentMinutes - 1;
    return minutes < 0 ? 59 : minutes;
};

export const addHour = (currentHours) => {
    const hours = currentHours + 1;
    return hours > 23 ? 0 : hours;
};

export const deductHour = (currentHours) => {
    const hours = currentHours - 1;
    return hours < 0 ? 23 : hours;
};

export const displayHours = (currentHours) => {
    const calcHours = (hr) => hr > AM_DIFF ? hr - AM_DIFF : hr;
    const hours = currentHours === 0 ? AM_DIFF : calcHours(currentHours);
    return hours;
};

export const displayMinutes = (currentMinutes) => padStart(currentMinutes, 2, '0');

export const displayAmPmLabel = (currentHours) => currentHours <= 11 ? 'AM' : 'PM';
