import React from 'react';
import R from 'ramda';
import classNames from 'classnames';
import {XlReactTreeRowComponent} from './xl-react-tree-row-component';
import {xlReactTreeRowIconRenderer} from './xl-react-tree-row-icon-renderer';

export const xlReactTreeRowRenderer = (node, treeOptions) => {
    const {
        id, name, type, icon, renameMode, contextMenu = true
    } = node;

    const label = renameMode ?
        <input
            className="infinite-tree-rename-input"
            data-current-value={name}
            data-id={id}
            defaultValue={name}
            type="text"
        /> : <span className="infinite-tree-title" data-id={id} data-type={type}>{name}</span>;

    const className = classNames('infinite-tree-closed', {'context-menu-button': contextMenu}, 'pull-right');
    const isDraggable = R.has('type')(node);
    return (
        <XlReactTreeRowComponent
            data-type={node.type}
            draggable={isDraggable}
            node={node}
            togglerClass={treeOptions.togglerClass}>
            {xlReactTreeRowIconRenderer(icon)}
            {label}
            <i className={className} data-id={id} data-type={type}/>
        </XlReactTreeRowComponent>
    );
};
