import Q from 'q';
import gulp from 'gulp';
import webpack from 'webpack';
import WebpackDevServer from 'webpack-dev-server';
import webpackDevConfig from './webpack/webpack.config.dev';

import {runExpress} from './file-upload';
import serverPort from '../utils/port';

gulp.task('dev-server', () => {
    const serverStarted = Q.defer();
    const webpackInstance = webpack(webpackDevConfig);
    webpackInstance.hooks.done.tap('XLServer', () => serverStarted.resolve());
    const server = new WebpackDevServer(webpackInstance, {
        disableHostCheck: true,
        historyApiFallback: true,
        hot: true,
        lazy: false,
        noInfo: false,
        publicPath: webpackDevConfig.output.publicPath,
        quiet: false,
        stats: {colors: true}
    });
    server.listen(serverPort);
    return serverStarted.promise;
});

gulp.task('express', () => {
    runExpress();
});
