import express from 'express';
import fileUpload from 'express-fileupload';

let server = null;

export const runExpress = () => {
    const app = express();

    app.use(fileUpload());

    app.use((req, res, next) => {
        res.setHeader('Access-Control-Allow-Origin', '*');
        res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE');
        res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,contenttype');
        res.setHeader('Access-Control-Allow-Credentials', true);
        next();
    });

    app.post('/upload', (req, res) => {
        if (!req.files) {
            res.status(500).send({message: 'No files were uploaded.'});
            return;
        }

        const file = req.files.fileName;
        const fileName = file.name;

        res.send({message: `File ${fileName} has been uploaded`});
    });

    server = app.listen(3002);
};

export const stopServer = () => {
    if (server) {
        server.close();
    }
};