const autoprefixer = require('autoprefixer');
const gradientfixer = require('postcss-gradientfixer');
const doiuse = require('doiuse');

module.exports = {
    plugins: [
        autoprefixer({overrideBrowserslist: ['last 2 versions']}),
        gradientfixer(),
        doiuse({
            browsers: ['ie >= 11', 'last 2 Chrome versions', 'last 2 Firefox versions'],
            ignore: ['flexbox', 'font-unicode-range', 'outline', 'calc', 'css-resize', 'css-initial-value',
                'css-masks', 'css-image-set', 'css3-cursors-newer', 'text-size-adjust', 'will-change',
                'css-appearance'],
            ignoreFiles: [
                '**/bootstrap*.css',
                '**/react-select.css',
                '**/react-datepicker.css',
                '**/monaco-editor/**/**.css'
            ],
            onFeatureUsage: (val) => {
                throw new Error(`You are using not supported CSS by all specified browsers. ${val.message}`);
            }
        })
    ]
};
