import {Expectation, Window} from 'protractor-base-dsl';

export const changeText = (text) => {
    browser.executeScript(`this.monaco.editor.getModels()[0].setValue("${text}")`);
};

const editorSelector = '.xl-react-widget-monaco-editor .react-monaco-editor-container .monaco-editor';
const viewLineSelector = '.monaco-scrollable-element > .lines-content > .view-lines > .view-line';

const getLine = (lineNumber) => `${viewLineSelector}:nth-child(${lineNumber}) > span > span`;

const checkLines = (selector, lines = []) => {
    Expectation.count(viewLineSelector, lines.length);
    lines.forEach((line, index) => {
        Expectation.textEquals(getLine(index + 1), line);
    });
};

const shouldResizeEditor = () => {
    const editor = element(By.css(editorSelector));

    editor.getSize().then((size) => {
        Window.setSize(global.defaultBrowserWidth + 100, global.defaultBrowserHeight);
        editor.getSize().then((currentSize) => {
            expect(currentSize.width > size.width).toEqual(true);
            Window.setSize(global.defaultBrowserWidth, global.defaultBrowserHeight);
        });
    });
};

export default {changeText, checkLines, shouldResizeEditor};
