import {
    Action,
    Expectation
} from 'protractor-base-dsl';

import {argv} from 'yargs';

const navBarSelector = '#root .kitchenApp .nav';

class Navigation {
    static openButtonElement(modelName) {
        Action.jsClick(`${navBarSelector} a.buttons`);
        Expectation.displayed('main > .buttons-page');
        Action.jsClick(`.navigation.${modelName}`);
    }

    static openDipElement(modelName) {
        Action.jsClick(`${navBarSelector} a.dip`);
        Expectation.displayed('main > .dip-page');
        Action.jsClick(`.navigation.${modelName}`);
    }

    static openFormElement(modelName) {
        Action.jsClick(`${navBarSelector} a.form`);
        Expectation.displayed('main > .form-page');
        Action.jsClick(`.navigation.${modelName}`);
    }

    static openTabSystemPage() {
        Action.jsClick(`${navBarSelector} a.tabsystem`);
        Expectation.displayed('main > .tabs-page');
    }

    static openWidgetElement(modelName) {
        Action.jsClick(`${navBarSelector} a.widget`);
        Expectation.displayed('main > .widget-page');
        Action.jsClick(`.navigation.${modelName}`);
    }

    static openHomePage() {
        browser.driver.get(`http://${appHost}:${argv.params.proxyPort}/`);
    }
}

export default Navigation;
global.Navigation = Navigation;
