import {Action, Expectation} from 'protractor-base-dsl';
import WidgetAutocomplete from '../widget/widget-autocomplete';

export const addButtonDisabled = () =>
    Expectation.disabled('.testComponent .xl-react-components-input .xl-btn-add');

export const clickAddButton = () =>
    Action.click('.testComponent .xl-react-components-input .xl-btn-add');

export const expectSelectedItemToEqual = (itemNumber, value) => {
    const selector = `.testComponent .xl-scrollable-panel .xl-list-row:nth-child(${itemNumber}) .text-container`;
    return Expectation.textEquals(selector, value);
};

export const removeSelectedItem = (itemNumber) => {
    const rowSelector = `.testComponent .xl-scrollable-panel .xl-list-row:nth-child(${itemNumber})`;
    return Action.click(`${rowSelector} .close-icon`);
};

const DipListAutocomplete = {
    ...WidgetAutocomplete,
    addButtonDisabled,
    clickAddButton,
    expectSelectedItemToEqual,
    removeSelectedItem
};

export default DipListAutocomplete;
global.DipListAutocomplete = DipListAutocomplete;
