import {Action, Expectation} from 'protractor-base-dsl';

const close = () =>
    Action.click('.xl-react-modal-dialog .xl-react-modal-content .modal-header .close-icon');
const clickCondense = () =>
    Action.click('.modal-expanded .xl-react-modal-content .modal-header .fullscreen-exit-icon');
const clickExpand = () =>
    Action.click('.xl-react-modal-dialog .xl-react-modal-content .modal-header .fullscreen-icon');
const expectHeader = (headerText) =>
    Expectation.textEquals('.xl-react-modal-dialog .xl-react-modal-content .modal-header h4', headerText);
const expectContentContains = (contentText) =>
    Expectation.textContains('.xl-react-modal-dialog .xl-react-modal-content .widget-dialog-text', contentText);
const expectNotPresent = () =>
    Expectation.notPresent('.xl-react-modal-dialog');
const expectHeaderHasClassName = (className) =>
    Expectation.hasClassName('.xl-react-modal-dialog .xl-react-modal-content .modal-header', className);

const WidgetDialog = {
    close,
    clickCondense,
    clickExpand,
    expectContentContains,
    expectHeader,
    expectHeaderHasClassName,
    expectNotPresent
};
export default WidgetDialog;
global.WidgetDialog = WidgetDialog;
