import R from 'ramda';
import {Action, Expectation} from 'protractor-base-dsl';

const nodeSelector = (nodeNumber) => `.testComponent .infinite-tree-item:nth-of-type(${nodeNumber})`;

const bulkCtrlClickNodes = (nodeNumbers) => Action.bulkCtrlKey(R.map(nodeSelector, nodeNumbers));
const bulkShiftClickNodes = (nodeNumbers) =>
    Action.bulkShiftKey(R.map(nodeSelector, nodeNumbers));
const expectNode = (nodeNumber, dataId) =>
    Expectation.attributeContainsValue(nodeSelector(nodeNumber), 'data-id', dataId);
const expectNodeCollapsed = (nodeNumber) =>
    Expectation.attributeContainsValue(nodeSelector(nodeNumber), 'data-expanded', false);
const expectNodeExpanded = (nodeNumber) =>
    Expectation.attributeContainsValue(nodeSelector(nodeNumber), 'data-expanded', true);
const expectNodeLoading = (nodeNumber) => {
    const selector = `${nodeSelector(nodeNumber)} .infinite-tree-toggler`;
    Expectation.attributeContainsValue(selector, 'class', 'infinite-tree-loading');
};
const expectNodeSelected = (nodeNumber) =>
    Expectation.attributeContainsValue(nodeSelector(nodeNumber), 'data-selected', true);
const expectNodeNotSelected = (nodeNumber) =>
    Expectation.attributeContainsValue(nodeSelector(nodeNumber), 'data-selected', false);
const selectNode = (nodeNumber) =>
    Action.click(nodeSelector(nodeNumber));
const toggleNode = (nodeNumber) =>
    Action.click(`${nodeSelector(nodeNumber)} .infinite-tree-toggler`);

const WidgetTree = {
    bulkCtrlClickNodes,
    bulkShiftClickNodes,
    expectNode,
    expectNodeCollapsed,
    expectNodeExpanded,
    expectNodeLoading,
    expectNodeNotSelected,
    expectNodeSelected,
    selectNode,
    toggleNode
};
export default WidgetTree;
global.WidgetTree = WidgetTree;
