import {Action, Expectation} from 'protractor-base-dsl';

const rootSelector = '.xl-react-widget-confirmation-dialog-container-default';
const confirmationDialogShowButtonSelector = `${rootSelector} .testBindings .xl-react-button`;
const dialogSelector = '.xl-react-widget-confirmation-dialog';
const primaryBtnSelector = `${dialogSelector} .dialog-buttons .xl-primary`;
const secondaryBtnSelector = `${dialogSelector}  .dialog-buttons .xl-secondary`;
const headerSelector = `${dialogSelector} .modal-header .modal-title .title`;
const contentSelector = `${dialogSelector} .confirmation-content > div`;

const openConfirmationDialog = () =>
    Action.click(confirmationDialogShowButtonSelector);
const clickOnPrimaryButton = () =>
    Action.click(primaryBtnSelector);
const clickOnSecondaryButton = () =>
    Action.click(secondaryBtnSelector);

const expectHeader = (headerText) =>
    Expectation.textEquals(headerSelector, headerText);
const expectContent = (contentText) =>
    Expectation.textEquals(contentSelector, contentText);
const expectPrimaryButton = (contentText) =>
    Expectation.textEquals(primaryBtnSelector, contentText);
const expectSecondaryButton = (contentText) =>
    Expectation.textEquals(secondaryBtnSelector, contentText);
const expectNotPresent = () =>
    Expectation.notPresent(dialogSelector);
const expectPresent = () =>
    Expectation.present(dialogSelector);

const WidgetConfirmationDialogContainer = {
    clickOnPrimaryButton,
    clickOnSecondaryButton,
    expectContent,
    expectHeader,
    expectPrimaryButton,
    expectSecondaryButton,
    expectNotPresent,
    expectPresent,
    openConfirmationDialog
};

export default WidgetConfirmationDialogContainer;
global.WidgetConfirmationDialogContainer = WidgetConfirmationDialogContainer;
