import R from 'ramda';
import Navigation from '../../../dsl/common/navigation';
import TestBindings from '../../../dsl/common/test-bindings';
import DipCi from '../../../dsl/component/dip/dip-ci';

describe('XL DIP Ci Scenario', () => {
    afterAll(() => TestBindings.resetPristinity());
    beforeAll(() => Navigation.openDipElement('dipCi1'));

    it('should have right initial state', () => {
        TestBindings.expectModelToEqual('');
        TestBindings.expectPristineToEqual('true');
        TestBindings.expectValidToEqual('true');
        DipCi.expectLabel('Autocomplete');
        DipCi.expectDescription('This is my autocomplete field.');
    });

    it('should show options and provide search', () => {
        DipCi.openSelection();

        for (const index of R.range(1, 6)) {
            DipCi.expectSuggestionValue(index, `Application${index}`);
        }

        DipCi.setValue('1');
        DipCi.expectSuggestionValue(1, 'Application1');
        DipCi.selectOption(1);
        TestBindings.expectModelToEqual('Application1');
        TestBindings.expectPristineToEqual('false');
        TestBindings.expectValidToEqual('true');
        DipCi.clearSelection();
        TestBindings.expectModelToEqual('');
    });
});
