import Navigation from '../../../dsl/common/navigation';
import TestBindings from '../../../dsl/common/test-bindings';
import DipEnum from '../../../dsl/component/dip/dip-enum';

describe('XL DIP Enum (Radio) Scenario', () => {
    afterAll(() => TestBindings.resetPristinity());
    beforeAll(() => {
        Navigation.openDipElement('dipEnum1');
        DipEnum.toggleRadioView();
    });

    it('should have right initial state when pristine', () => {
        TestBindings.expectModelToEqual('eagle');
        TestBindings.expectPristineToEqual('true');
        TestBindings.expectValidToEqual('true');
        DipEnum.expectLabel('Enum Label');
        DipEnum.expectDescription('Select a string');
    });

    it('should show change model', () => {
        TestBindings.expectModelToEqual('eagle');
        DipEnum.setRadioValue(1);
        TestBindings.expectModelToEqual('ace');
        TestBindings.expectPristineToEqual('false');
        TestBindings.expectValidToEqual('true');
        DipEnum.setRadioValue(3);
        TestBindings.expectModelToEqual('eagle');
        TestBindings.expectPristineToEqual('false');
        TestBindings.expectValidToEqual('true');
    });

    it('should be disabled when "disabled" option is chosen', () => {
        DipEnum.expectRadioInputEnabled();
        TestBindings.toggleDisabled();
        DipEnum.expectRadioInputDisabled();
        TestBindings.toggleDisabled();
        DipEnum.expectRadioInputEnabled();
    });
});
