import Navigation from '../../dsl/common/navigation';
import WidgetString from '../../dsl/component/widget/widget-string';
import WidgetStringButtonAddon from '../../dsl/component/widget/widget-button-addon';
import TestBindings from '../../dsl/common/test-bindings';

describe('XL Widget with button addon Scenario', () => {
    beforeAll(() => Navigation.openWidgetElement('widgetStringWithButtonAddon'));

    it('should have right initial state', () => {
        TestBindings.expectObjectModelToEqual({button: '', filter: ''});
        TestBindings.expectValidToEqual('true');
        TestBindings.expectPristineToEqual('true');
        WidgetString.expectPlaceholderToEqual('String placeholder');
        WidgetString.expectDescription('This is my string field.');
        WidgetString.expectLabel('String with button addon');
    });

    it('should be disabled when "disabled" option is chosen', () => {
        WidgetString.expectNotReadonlyInput();
        TestBindings.toggleDisabled();
        WidgetString.expectReadonlyInput();
        TestBindings.toggleDisabled();
        WidgetString.expectNotReadonlyInput();
    });

    it('should select button and text typed in input field on key Enter', () => {
        WidgetStringButtonAddon.setValue('1');
        TestBindings.expectObjectModelToEqual({button: '', filter: '1'});
        WidgetStringButtonAddon.selectButtonValue('One');
        TestBindings.expectObjectModelToEqual({button: 'One', filter: '1'});
        WidgetString.expectClearIconPresent();
        TestBindings.expectPristineToEqual('false');
        WidgetString.clearValue();
        TestBindings.expectPristineToEqual('false');
        WidgetString.expectClearIconNotPresent();
        TestBindings.expectObjectModelToEqual({button: 'One', filter: ''});
    });
});
