import Navigation from '../../dsl/common/navigation';
import TestBindings from '../../dsl/common/test-bindings';
import WidgetDialog from '../../dsl/component/widget/widget-dialog';

describe('XL Widget Modal Dialog Scenario', () => {
    it('should be able to open and close modal dialog', () => {
        Navigation.openWidgetElement('widgetModalDialog1');
        TestBindings.show();
        WidgetDialog.expectHeader('Modal dialog');
        WidgetDialog.expectContentContains('Lorem Ipsum.');
        WidgetDialog.close();
        WidgetDialog.expectNotPresent();
    });

    it('should be able to expand and condense expandable modal dialog', () => {
        Navigation.openWidgetElement('widgetModalDialog2');
        TestBindings.show();
        WidgetDialog.expectHeader('Expandable modal dialog');
        WidgetDialog.expectContentContains('Lorem Ipsum.');
        WidgetDialog.expectHeaderHasClassName('fullscreen-icon');
        WidgetDialog.clickExpand();
        WidgetDialog.expectHeaderHasClassName('fullscreen-exit-icon');
        WidgetDialog.clickCondense();
        WidgetDialog.expectHeaderHasClassName('fullscreen-icon');
        WidgetDialog.close();
        WidgetDialog.expectNotPresent();
    });
});
