import Navigation from '../../../dsl/common/navigation';
import WidgetPatchSample from '../../../dsl/component/widget/widget-patch-sample';

describe('XL Widget Patch Sample Scenario', () => {
    beforeAll(() => Navigation.openWidgetElement('widgetPatchSample'));

    it('should have right initial state', () => {
        WidgetPatchSample.expectedNoSelectedLine();
        WidgetPatchSample.expectLineContent(1, 'apiVersion: v1');
        WidgetPatchSample.expectLineContent(2, 'kind: Pod');
        WidgetPatchSample.expectHeaderLabel('Sample');
        WidgetPatchSample.expectFilePath('Environments/Patch-1');
    });

    it('should be able to select the line', () => {
        WidgetPatchSample.selectLine(1);
        WidgetPatchSample.expectedSelectedLine(1);

        WidgetPatchSample.selectLine(3);
        WidgetPatchSample.expectedSelectedLine(3);
    });
});
