import {isValidEnumValue} from '~/app/services/validate-service';

describe('validate-service', () => {
    describe('isValidEnumValue', () => {
        it('should be valid if no enum values provided', () => {
            expect(isValidEnumValue({})).toBeTruthy();
        });
        it('should be valid if enum is not required and no value provided', () => {
            expect(isValidEnumValue({enumValues: ['apple']})).toBeTruthy();
        });
        it('should be invalid if enum is required and no value provided', () => {
            expect(isValidEnumValue({enumValues: ['apple'], required: true})).toBeFalsy();
        });
        it('should be invalid if value is not in suggestions', () => {
            expect(isValidEnumValue({checkedValue: 'banana', enumValues: ['apple', 'pear']})).toBeFalsy();
        });
        it('should be valid if value is in suggestions', () => {
            expect(isValidEnumValue({checkedValue: 'pear', enumValues: ['apple', 'pear']})).toBeTruthy();
        });
    });
});
