import {sortStrings} from '~/app/utils/sorting-utils';

describe('Sorting utils', () => {
    describe('sortStrings', () => {
        it('should sort strings in ascending order', () => {
            expect(sortStrings(['b', 'a', 'c'])).toEqual(['a', 'b', 'c']);
            expect(sortStrings(['b', 'A', 'c'])).toEqual(['A', 'b', 'c']);
            expect(sortStrings(['b', 'A', 'c'], 'ASC')).toEqual(['A', 'b', 'c']);
        });

        it('should sort strings in descending order', () => {
            expect(sortStrings(['b', 'a', 'c'], 'DESC')).toEqual(['c', 'b', 'a']);
            expect(sortStrings(['b', 'A', 'c'], 'DESC')).toEqual(['c', 'b', 'A']);
        });
    });
});
