import {lastUpdatedTimestamp} from '../../../../app/xl-react-widget/xl-react-widget-last-time-updated/time-formatter';

describe('time-formatter', () => {
    describe('lastUpdatedTimestamp', () => {
        const date = new Date(2020, 6, 1, 14, 53, 20, 100);
        it('should format date time with default formatter', () => {
            expect(lastUpdatedTimestamp(date))
                .toEqual('Last updated: Jul 1, 2020 - 2:53:20 PM');
        });

        it('should format date with custom formatter', () => {
            expect(lastUpdatedTimestamp(date, 'MMM D, YYYY'))
                .toEqual('Last updated: Jul 1, 2020');
        });

        it('should return empty string if no date is passed', () => {
            expect(lastUpdatedTimestamp(undefined))
                .toEqual('Last updated: ');
        });
    });
});
