import {
    addHour,
    addMinute,
    deductHour,
    deductMinute,
    displayAmPmLabel,
    displayHours,
    displayMinutes
} from '~/app/xl-react-widget/xl-react-widget-time/xl-react-widget-time-service';

describe('xl-react-widget-time-service', () => {
    it('should add a minute to current minutes', () => {
        expect(addMinute(59)).toBe(0);
        expect(addMinute(58)).toBe(59);
    });

    it('should deduct a minute from current minutes', () => {
        expect(deductMinute(1)).toBe(0);
        expect(deductMinute(0)).toBe(59);
    });

    it('should add an hour to current hours', () => {
        expect(addHour(23)).toBe(0);
        expect(addHour(22)).toBe(23);
    });

    it('should deduct an hour from current hours', () => {
        expect(deductHour(1)).toBe(0);
        expect(deductHour(0)).toBe(23);
    });

    it('should display hours in 12-hour format', () => {
        expect(displayHours(23)).toBe(11);
        expect(displayHours(3)).toBe(3);
        expect(displayHours(0)).toBe(12);
        expect(displayHours(12)).toBe(12);
    });

    it('should display minutes', () => {
        expect(displayMinutes(3)).toBe('03');
        expect(displayMinutes(10)).toBe('10');
    });

    it('should display AM PM label', () => {
        expect(displayAmPmLabel(12)).toBe('PM');
        expect(displayAmPmLabel(11)).toBe('AM');
        expect(displayAmPmLabel(10)).toBe('AM');
    });
});
