import React from 'react';
import {mount} from 'enzyme';

import {widgetInitialState} from '~/app/pages/widget-page/widget-initial-state';
import {XlReactWidgetTree} from '~/app/xl-react-widget/xl-react-widget-tree/xl-react-widget-tree';
import {xlReactTreeRowRenderer} from '~/app/xl-react-widget/xl-react-widget-tree/row/xl-react-tree-row-renderer';

describe('XlReactWidgetTree', () => {
    const onNodesSelected = jest.fn();

    const defaultProps = {
        ...widgetInitialState.widgetTree1,
        autoOpen: true,
        onNodesSelected,
        rowRenderer: xlReactTreeRowRenderer
    };

    let wrapper;

    beforeEach(() => {
        wrapper = mount(<XlReactWidgetTree {...defaultProps}/>);
    });

    it('should render correctly', () => {
        expect(wrapper.instance().tree.nodes.length).toBe(16);
    });
});

